#!/bin/bash

function check_status_meta()
{
 outFile=$2
 host=$1
 if  [ "$host" != "" ]
 then
   ssh -qq -oStrictHostKeyChecking=no $host ps aux | grep fhgfs_meta | grep -v grep 2>&1>/dev/null
   if [ $? -eq 0 ]
   then
#     status="Running"
     status="true"
   else
#     status="Not Running"
     status="false"
   fi
   (
     exec 200>/tmp/fhgfs.lock;
     flock -x 200
     echo "${host},${status}" >> ${outFile}
   )
 else
   return 1
 fi
}

function check_status_storage()
{
 outFile=$2
 host=$1
 if  [ "$host" != "" ]
 then
   ssh -qq -oStrictHostKeyChecking=no $host ps aux | grep fhgfs_storage | grep -v grep 2>&1>/dev/null
   if [ $? -eq 0 ]
   then
#     status="Running"
     status="true"
   else
#     status="Not Running"
     status="false"
   fi
   (
     exec 200>/tmp/fhgfs.lock;
     flock -x 200
     echo "${host},${status}" >> ${outFile}
   )
 else
   return 1
 fi
}

function check_status_mgmtd()
{
 outFile=$2
 host=$1
 if  [ "$host" != "" ]
 then
   ssh -qq -oStrictHostKeyChecking=no $host ps aux | grep fhgfs_mgmtd | grep -v grep 2>&1>/dev/null
   if [ $? -eq 0 ]
   then
#     status="Running"
     status="true"
   else
#     status="Not Running"
     status="false"
   fi
   (
     exec 200>/tmp/fhgfs.lock;
     flock -x 200
     echo "${host},${status}" >> ${outFile}
   )
 else
   return 1
 fi
}


function check_status_client()
{
 outFile=$2
 host=$1
 if  [ "$host" != "" ]
 then
#   ssh -qq -oStrictHostKeyChecking=no ${host} lsmod | grep fhgfs_client 2>&1>/dev/null
#   if [ $? -eq 0 ]
#   then
#     echo "Kernel module loaded - "
#   else
#     echo "Kernel module not loaded - "
#   fi
#   if [ $? -ne 0 ]
#   then
      
#   fi
   status=true
   for i in $(ssh -qq -oStrictHostKeyChecking=no ${host} cat /etc/fhgfs/fhgfs_mounts.conf | cut -f 1 -d " ")
   do
    ssh -qq -oStrictHostKeyChecking=no ${host} mount | grep ${i} 2>&1>/dev/null
    if [ $? -ne 0 ]
    then
       status=false      
    fi         
   done
   (
     exec 200>/tmp/fhgfs.lock;
     flock -x 200
     echo "${host},${status}" >> ${outFile}
   )

 else
   return 1
 fi
}


if [ "$2" = "" ]
then 
 exit 1
fi

host=$2

if [ "$3" = "" ]
then
 outFile=/dev/stdout
else
 outFile=$3
fi


if [ "$1" = "meta" ]
then
 check_status_meta $host $outFile
 exit $?
elif [ "$1" = "storage" ]
then
 check_status_storage $2 $outFile
 exit $?
elif [ "$1" = "mgmtd" ]
then
 check_status_mgmtd $host $outFile 
 exit $?
elif [ "$1" = "client" ]
then
 check_status_client $host $outFile
 exit $?
fi
