#!/bin/bash

dirname=$(dirname $0)

. ${dirname}/fhgfs_setup.defaults

if [ -e ${confdir}/config ]
then
  . ${confdir}/config
fi


function write_config() {
   for module in fhgfs_storage fhgfs_meta fhgfs_client fhgfs_helperd fhgfs_admon fhgfs_mgmtd 
    do 
        cp ${confdir}/${module}.conf.template ${confdir}/${module}.conf.master
      # get a list of all configurable options in the config file
      #   and replace every occurence
         for option in $(grep -o '%.*%' ${confdir}/${module}.conf.template | tr -d %)
         do 
           sed -i 's|%'${option}'%|'${!option}'|g' ${confdir}/${module}.conf.master
         done
    done

    echo "${clientMount} /etc/fhgfs/fhgfs_client.conf" > ${confdir}/fhgfs_mounts.conf
}

write_config
if [ $? -ne 0 ];then exit 1;fi
