#!/bin/bash

dirname=$(dirname $0)

. ${dirname}/fhgfs_setup.defaults

IFS="
"

NUM=0
QUEUE=""
MAX_NPROC=10
COUNTER=0

function queue() {
        QUEUE="$QUEUE $1"
        NUM=$(($NUM+1))
}

function regeneratequeue() {
        OLDREQUEUE=$QUEUE
        QUEUE=""
        NUM=0
        for PID in $OLDREQUEUE
        do
                if [ -d /proc/$PID  ] ; then
                        QUEUE="$QUEUE $PID"
                        NUM=$(($NUM+1))
                fi
        done
}

function checkqueue() {
        OLDCHQUEUE=$QUEUE
        for PID in $OLDCHQUEUE
        do
                if [ ! -d /proc/$PID ] ; then
                        regeneratequeue # at least one PID has finished
                        break
                fi
        done
}




function check_distri_arch()
{
#  a=$(seq 19999999) &
#  PID=$!
#  queue PID
  for host in $(cat ${metaFile} ${storageFile} ${clientFile} ${managementFile} | sort | uniq | cut -f 1 -d "," | tr -d " ")
  do
    (bash ${dirname}/fhgfs_setup.deployInfoSingle.sh ${host}) &
    PID=$!
    queue PID
    while [ $NUM -ge $MAX_NPROC ]; do
            checkqueue
            sleep 0.4
    done
  done
  wait
}

check_distri_arch
