#!/bin/bash

dirname=$(dirname $0)


. ${dirname}/fhgfs_setup.defaults

function check_distri_arch_one_shot()
{
 IFS="
"
 if [ "$1" = "" ]
 then
  return 1
 fi
 host=$1

 if [ $host = "" ]; then continue;fi
   # check distri 
 distri_tag="suse" # assume suse as long as nothing else is proven
   # SuSE check
 ssh -qq -oStrictHostKeyChecking=no ${host} "[ -e /etc/SuSE-release ]"
 if [ $? -eq 0 ]; then distri_tag="suse"; distri=$(ssh ${host} "cat /etc/SuSE-release | head -n 1"); fi
   # Fedora check
 ssh -qq -oStrictHostKeyChecking=no ${host} "[ -e /etc/fedora-release ]"
 if [ $? -eq 0 ]; then distri_tag="rh"; distri=$(ssh ${host} "cat /etc/fedora-release | head -n 1"); fi
 ssh -qq -oStrictHostKeyChecking=no ${host} "[ -e /etc/redhat-release ]"
 if [ $? -eq 0 ]; then distri_tag="rh"; distri=$(ssh ${host} "cat /etc/redhat-release | head -n 1"); fi
 ssh -qq -oStrictHostKeyChecking=no ${host} "[ -e /etc/centos-release ]"
 if [ $? -eq 0 ]; then distri_tag="rh"; distri=$(ssh ${host} "cat /etc/centos-release | head -n 1"); fi
 ssh -qq -oStrictHostKeyChecking=no ${host} "[ -e /etc/debian_version ]"  # also for ubuntu
 if [ $? -eq 0 ]; then distri_tag="debian"; version=$(ssh ${host} "cat /etc/debian_version | head -n 1"); distri="Debian ${version}"; fi
   
   # check arch
 arch="i586" # assume x86 32 bit as long as nothing else is proven
 ssh -qq -oStrictHostKeyChecking=no ${host} "uname -a | grep 'x86_64'" > /dev/null
 if [ $? -eq 0 ]; then arch="x86_64"; fi
 ssh -qq -oStrictHostKeyChecking=no ${host} "uname -a | grep 'ppc'" > /dev/null
 if [ $? -eq 0 ]; then arch="ppc"; fi
 ssh -qq -oStrictHostKeyChecking=no ${host} "uname -a | grep 'ppc64'" > /dev/null
 if [ $? -eq 0 ]; then arch="ppc64"; fi
   
 sed -i 's!'"${host}".*'!'"${host}"','"${arch}"','"${distri}"','"${distri_tag}"'!' ${metaFile}   
 sed -i 's!'"${host}".*'!'"${host}"','"${arch}"','"${distri}"','"${distri_tag}"'!' ${storageFile}   
 sed -i 's!'"${host}".*'!'"${host}"','"${arch}"','"${distri}"','"${distri_tag}"'!' ${clientFile}   
 sed -i 's!'"${host}".*'!'"${host}"','"${arch}"','"${distri}"','"${distri_tag}"'!' ${managementFile}   
 
 return 0
}


if [ "$1" = "" ]
then
 return 1
fi

check_distri_arch_one_shot $1
if [ $? -ne 0 ]; then exit 1; fi
